#ifndef __HW_VI_H
#define __HW_VI_H 1


#include "general.h"
#include "mem.h"
#include "video.h"

#define RVI_SIZE			0x100
#define RVI_MASK			0x0ff

// reversed addressing space
#ifdef LIL_ENDIAN
# define RVI16(X)			(*((__u16 *) &rvi[RVI_SIZE - ((X) & RVI_MASK) - 2]))
# define RVI32(X)			(*((__u32 *) &rvi[RVI_SIZE - ((X) & RVI_MASK) - 4]))
#else
# define RVI16(X)			(*((__u16 *) &rvi[(X) & RVI_MASK]))
# define RVI32(X)			(*((__u32 *) &rvi[(X) & RVI_MASK]))
#endif

extern __u8 rvi[RVI_SIZE];


#define VI_BASE				(0x2000)
#define VI_VCT				(VI_BASE + 0x2c)
#define VI_HCT				(VI_BASE + 0x2e)

#define VI_DINT0			(VI_BASE + 0x30)
#define VI_DINT1			(VI_BASE + 0x34)
#define VI_DINT2			(VI_BASE + 0x38)
#define VI_DINT3			(VI_BASE + 0x3c)

#define VI_DI_INTEN		0x10000000
#define VI_DI_INT			0x80000000

#define VI_MODE				(0x2000)
#define VI_XFB1				(0x201c)
#define VI_XFB2				(0x2024)


void vi_init (void);
void vi_reinit (void);
void vi_refresh (void);


#endif // __HW_VI_H
